<?php
defined('_JEXEC') or die;
class JXDSefHelper extends JPlugin{
	private $cache = null;
	function __construct(&$subject, $config = array()) {
		$options = array('component'=>'xdsef','lifetime'=>JFactory::getConfig()->get('cachetime')*60);
		$this->cache = new JCache($options);
		parent::__construct($subject, $config);
	}
	
	private $idToAlias = array();
	
	function getItemPathByCategoryId($id) {
		if ($result = $this->cache->get($key = 'getItemPathByCategoryId'.$id)) {
			return $result;
		}
		$category = JCategories::getInstance('Content')->get($id);
		if (!$category) {
			JError::raiseError(404, "Content not found");
		}
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		$query
			->select('path')
			->from('#__menu')
			->where(array(
				'alias='.$db->quote($category->alias),
				'menutype="mainmenu"',
			));
		
		$db->setQuery($query, 0, 1);
		$menu = $db->loadObject();
		if ($menu) {
			$path = explode('/', $menu->path);
			$this->cache->store($path, $key, 'system');
			return $path;
		} else {
			return $this->getCategoryPathById($id);
		}
	}
	function getCategoryIdByPath($path) {
		if ($id = $this->cache->get($key = 'getCategoryIdByPath'.md5(serialize($path)))) {
			return $id;
		}
		$k = count($path)-1;
		do{
			$alias = $path[$k];
		}while($k-->0 and !$alias);
		
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		$query
			->select('id')
			->from('#__categories')
			->where(array(
				'alias='.$db->quote($alias),
				'extension="com_content"',
			));
		
		$db->setQuery($query, 0, 1);
		$id = $db->loadObject()->id;
		if (!$id) {
			JError::raiseError(404, "Content not found");
		}
		
		$this->cache->store($id, $key, 'system');
		return $id;
	}
	function getCategoryPathById($id) {
		if ($path = $this->cache->get($key = 'getCategoryPathById'.$id)) {
			return $path;
		}
		$category = JCategories::getInstance('Content')->get($id);
		if (!$category) {
			JError::raiseError(404, "Content not found");
		}
		$path = array();
		while ($category && $category->id > 1){
			array_unshift($path, $category->alias);
			$category = $category->getParent();
		}

		$this->cache->store($path, $key, 'system');
		return $path;
	}	
	function getIdFromAlias($alias, $component = 'content') {
		if ($id = $this->cache->get($key = 'getIdFromAlias'.$component.md5($alias))) {
			return $id;
		}
		
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		$query
			->select('id')
			->from($db->quoteName('#__'.$component))
			->where(array('alias='.$db->quote($alias)));
		
		$db->setQuery($query, 0, 1);
		$id = $db->loadObject()->id;
		if (!$id) {
			JError::raiseError(404, "Content not found");
		}
		
		$this->cache->store($id, $key, 'system');
		
		return $id;
	}
	function getAliasFromId($id, $component = 'content') {
		if (!is_numeric($id)) {
			list($id) = explode(':', $id);
		}
		if ($alias = $this->cache->get($key = 'getIdFromAlias'.$component.$id)) {
			return $alias;
		}
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		$query
			->select('alias')
			->from($db->quoteName('#__'.$component))
			->where(array('id='.intval($id)));
		
		$db->setQuery($query, 0, 1);
		
		$alias = $db->loadObject()->alias;
		
		if (!$alias and $component == 'content') {
			$alias = 'post-'.$id;
		}
		
		$this->cache->store($alias, $key, 'system');
		return $alias;
	}
}