<?php
/**
 * @copyright	Copyright (c) 2014 system. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

// no direct access
defined('_JEXEC') or die;

jimport('joomla.plugin.plugin');
include_once 'helper.php';
class plgsystemXDSef extends JXDSefHelper {
	private $iwork = false;
	function onAfterInitialise() {
        $app = JFactory::getApplication();
        if ($app->isAdmin()) {
            return;
        }

        $router = $app->getRouter();
        $router->attachBuildRule(array($this, 'build'));
        $router->attachParseRule(array($this, 'parse'));

        return true;
    }
    public function build(&$siteRouter, &$uri) {
        $path = $uri->getPath();
        $query = $uri->getQuery(true);

        switch ($query['option']) {
			case 'com_content':
				switch ($query['view']) {
					case 'article': 
					if (isset($query['id'])) {
						$path = $this->getAliasFromId($query['id']).'.html';
						unset($query['catid']);
						unset($query['option']);
						unset($query['view']);
						unset($query['id']);
					}
					break;
					case 'category': 
					if (isset($query['id'])) {
						//$path = implode('/', $this->getCategoryPathById($query['id']));
						$path = implode('/', $this->getItemPathByCategoryId($query['id']));
						unset($query['catid']);
						unset($query['option']);
						unset($query['view']);
						unset($query['id']);
						unset($query['layout']);
					}
					break;
				}
			break;
			case 'com_tags':
				$path = 'tag/'.$this->getAliasFromId($query['id'], 'tags');
				unset($query['option']);
				unset($query['view']);
				unset($query['id']);
			break;
		} 
	
        if ($path != $uri->getPath() || $query != $uri->getQuery(true)) {
            unset($query['Itemid']);

            $uri->setPath($path);
            $uri->setQuery($query);
        }

        return $uri;
    }
	 public function parse(&$siteRouter, &$uri) {
		// why?
		$doc = JFactory::getDocument();
		$doc->setBase(JURI::base());
		if ($this->iwork) {
			return $this->iwork;
		}
		$path = $uri->getPath();
        $path = str_replace(JURI::base() . '/', '', $path);
        $path = rtrim($path, '/');

        $newQuery = false;
        $itemId = null;
		
		if ($path) {
			if (preg_match('#(.*)\.html#ui', $path, $matches)) {
				$newQuery = 'option=com_content&view=article&id='.($id = $this->getIdFromAlias($matches[1]));
				$doc->setBase(JURI::base());
			} else {
				$_path = explode('/', $path);
				
				switch ($_path[0]) {
					case 'logout':break;
					case 'my-profile':break;
					case 'login':break;
					case 'register':break;
					case 'pages':break;
					case 'theme':break;
					case 'joomla':break;
					case 'component':break;
					case 'categories':break;
					case 'module-positions':break;
					case 'tag':
						$doc->setBase(JURI::base());
						$id = $this->getIdFromAlias($_path[1], 'tags');
						$newQuery = 'option=com_tags&view=tag&id='.$id.'-'.$_path[1];
					break;
					default:
						$doc->setBase(JURI::base());
						$id = $this->getCategoryIdByPath($_path);
						$newQuery = 'option=com_content&view=category&id='.$id.'&layout=blog';
				}
			}
		}
		
        if ($newQuery) {
            $oldQuery = $uri->getQuery(false);
            if (!empty($oldQuery)) {
				$newQuery = $newQuery.'&'.$oldQuery;
            }

            //Remove Itemid from the query
            $newQuery = preg_replace('#Itemid=[^&]*&#', '', $newQuery);
            $newQuery = preg_replace('#&?Itemid=.*#', '', $newQuery);

            $uri->setPath('');
            $uri->setQuery($newQuery);
			//print_r(parse_url($newQuery));
			parse_str($newQuery,$output);

			return $this->iwork = $output;
            //JFactory::getApplication()->input->set('Itemid', $itemId);
        }

        return array();
    }
}